<template>
    <div class="container border-radius-20">
        <div
            class="row justify-between"
            v-if="!state.client.name && state.displayPage == 'default'"
        >
            <div class="col-md-2 col-12 row">
                <q-btn
                    class="
                        border-radius-10
                        font-14
                        create-btn
                        card-item-btn
                        q-ma-md-md
                        col-12
                    "
                    size="lg"
                    no-caps
                    @click="state.displayPage = 'create'"
                >
                    Create Client Info
                </q-btn>
            </div>

            <!-- Search and Reset Button -->
            <div class="col-12 col-md-4 row justify-end">
                <q-btn
                    class="
                        border-radius-10
                        font-14
                        reset-btn
                        card-item-btn
                        q-ma-md-md q-mt-md q-mr-md
                        col-md-2 col-12
                    "
                    style="width: 100px; height: 40px"
                    size="md"
                    no-caps
                    @click="reset()"
                >
                    Reset
                </q-btn>
                <q-btn
                    class="
                        border-radius-10
                        font-14
                        search-btn
                        card-item-btn
                        q-ma-md-md q-mt-md
                        col-md-3 col-12
                    "
                    style="width: 130px; height: 40px"
                    size="md"
                    no-caps
                    @click="searchResult()"
                >
                    <q-icon name="search" />
                    Search
                </q-btn>
            </div>
        </div>
        <div class="center-tab" v-else-if="!state.client.name">
            <q-tabs
                v-model="tab"
                class="items-center tab-container"
                active-color="none"
                dense
                indicator-color="transparent"
                align="center"
                narrow-indicator
            >
                <q-tab
                    class="row justify-center tab-menu items-center"
                    flat
                    no-caps
                    name="add"
                    label="Add info"
                    items-center
                />
                <q-tab
                    class="row justify-center tab-menu items-center"
                    flat
                    no-caps
                    name="upload"
                    label="Upload file"
                    items-center
                />
            </q-tabs>
        </div>

        <!-- Filter -->
        <div
            class="row justify-between"
            v-if="!state.client.name && state.displayPage == 'default'"
        >
            <div class="col-md-8 col-12 row">
                <select-filter
                    class="col-6 col-md-3"
                    :model-value="state.selectedClient"
                    :header="`Client`"
                    :reset="state.reset"
                    @update-confirm="updateConfirm"
                />
            </div>
        </div>

        <div
            class="q-pb-md"
            v-else-if="state.displayPage == 'default' && state.client.name"
        >
            <h3 class="client-name">
                <q-btn flat @click="back()">
                    <q-icon name="arrow_back" />
                </q-btn>
                {{ state.client.name }}
                <actions-button
                    v-if="messageButtonCondition(allClientConvo[0])"
                    :conversation="allClientConvo[0]"
                />
            </h3>
        </div>

        <!-- Client's conversation Table -->
        <div class="row custom-row" v-if="state.displayPage == 'default'">
            <div class="col-12 scroll">
                <template v-if="state.client.name">
                    <div>
                        <h4>Conversations</h4>

                        <vue-data-table
                            :headers="clientHeaders2"
                            :data="formatData(allClientConvo)"
                            :actions="clientActions2"
                            @ticket-id-state="ticketIdState"
                            @update-tab="updateTab"
                            :requestConversationButtonPressed="
                                requestConversationButton
                            "
                            :transferConversationButtonPressed="
                                transferConversationButton
                            "
                            :ticketIDLinkPressed="ticketIDLinkPressed"
                            :conditionChatClient="true"
                        />
                    </div>
                </template>

                <template v-else>
                    <!-- Client Table -->
                    <vue-data-table
                        class="q-mx-lg-md q-mx-md-md q-mx-xs-none"
                        :headers="clientHeaders1"
                        :data="state.formatClients"
                        :left-align="clientLeftAlign1"
                        :actions="clientActions3"
                        :conditionChatClient="true"
                    />

                    <div class="col-12" v-if="state.pagination.total > 20">
                        <vue-data-pagination
                            :data="state.pagination"
                            :selectPagePressed="selectPagePressed"
                        ></vue-data-pagination>
                    </div>
                </template>
            </div>
        </div>

        <!-- Create Client Page -->
        <div v-else class="col-12 create-client">
            <q-tab-panels
                v-model="tab"
                animated
                class="bg-transparent no-scroll"
            >
                <q-tab-panel
                    name="add"
                    class="row justify-start no-scroll items-center q-pa-none"
                >
                    <create-customer @update-customer="updateCustomer" />
                </q-tab-panel>
                <q-tab-panel name="upload" class="scrollable-card-y q-pa-none">
                    <create-customer-upload @update-customer="updateCustomer" />
                </q-tab-panel>
            </q-tab-panels>
        </div>

        <!-- Client's appointment Table-->
        <div
            class="row custom-row"
            v-if="state.client.name && state.displayPage == 'default'"
        >
            <h4>Appointments</h4>
            <div class="col-12">
                <vue-data-table
                    :headers="clientHeaders3"
                    :data="state.appointments"
                    :left-align="clientLeftAlign1"
                />
            </div>
        </div>
    </div>
</template>
<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-explicit-any*/
/* eslint-disable @typescript-eslint/no-floating-promises */
/* eslint-disable @typescript-eslint/no-misused-promises */
/* eslint-disable @typescript-eslint/require-await */
/* eslint-disable @typescript-eslint/restrict-template-expressions */
/* eslint-disable @typescript-eslint/no-implicit-any-catch */

import {
    defineComponent,
    reactive,
    ref,
    watch,
    onMounted,
    computed
} from 'vue';
import SelectFilter from '../chats/SelectFilter.vue';
import CreateCustomerUpload from '../customer/CreateCustomerCSV.vue';
import VueDataTable from 'src/components/datatable/VueDataTable.vue';
import VueDataPagination from 'src/components/datatable/VueDataPagination.vue';
import CreateCustomer from 'src/components/customer/CreateCustomer.vue';
import ActionsButton from 'src/components/chats/ActionsButton.vue';
import { useRouter } from 'vue-router';
import { date } from 'quasar';
import { useStore } from 'src/store';
import { useI18n } from 'vue-i18n';
import localForage from 'localforage';
import { AppointmentStatus } from 'src/services/enums/AppointmentStatus';
import { orderBy } from 'lodash';
import { mapGetters } from 'vuex';
import { ConversationStatus } from 'src/services/enums/ConversationStatus';
import { FilterType } from 'src/services/enums/FilterType';

export default defineComponent({
    name: 'AllClient',
    components: {
        VueDataTable,
        VueDataPagination,
        SelectFilter,
        CreateCustomer,
        CreateCustomerUpload,
        ActionsButton
    },
    computed: {
        ...mapGetters({
            user: 'user/getUser'
        })
    },
    props: {
        requestConversationButton: {
            type: Function,
            default: () => ''
        },
        transferConversationButton: {
            type: Function,
            default: () => ''
        },
        ticketIDLink: {
            type: Function,
            default: () => ''
        }
    },
    setup(props, { emit }) {
        const router = useRouter();
        const store = useStore();
        const { t } = useI18n();
        const lang = store.state.user.user?.locale;

        const filterStore = localForage.createInstance({
            name: 'lobbi/filter'
        });

        let tab = ref(
            store.state.menu.selectedShortcut == 'business' || 'helpdesk'
                ? 'chatting'
                : store.state.menu.selectedShortcut
        );

        const changeStatusConvo = computed(() => {
            return store.state.conversation.changeStatusConvo;
        });

        const selectedTicketID = computed(() => {
            return store.state.conversation.selectedTicketID;
        });

        const allClientConvo = computed(() => {
            return store.state.conversation.allClient;
        });
        let state = reactive({
            selectedAgent: {} as any,
            selectedClient: {} as any,
            selectedIssueType: {} as any,
            selectedStatus: {} as any,
            formatClients: [] as any,
            formatClientsConversation: [] as any,
            ticketIdState: '',
            pagination: {
                page: 0,
                totalPage: 0,
                limit: 0,
                total: 0
            },
            displayPage: 'default',
            currentPage: 1,
            client: [] as any,
            reset: ref(false),
            clientConversation: [] as any,
            appointments: [] as any
        });

        watch(changeStatusConvo, async (currentValue) => {
            if (currentValue) {
                changeStatus(currentValue);
            }
        });

        watch(selectedTicketID, async (currentValue) => {
            if (currentValue) {
                ticketIdState(currentValue);
            }
        });
        const clientHeaders1 = [
            t('tables.client', {}, { locale: lang }),
            t('tables.phone', {}, { locale: lang }),
            t('tables.lastChat', {}, { locale: lang }),
            t('tables.actions', {}, { locale: lang })
        ];
        const clientLeftAlign1 = ['client'];

        const clientHeaders2 = [
            t('tables.dateTime', {}, { locale: lang }),
            t('tables.client', {}, { locale: lang }),
            t('tables.ticketId', {}, { locale: lang }),
            t('tables.issueType', {}, { locale: lang }),
            t('tables.lastAgent', {}, { locale: lang }),
            t('tables.status', {}, { locale: lang }),
            t('tables.actions', {}, { locale: lang })
        ];

        const clientHeaders3 = [
            t('tables.selectedDate', {}, { locale: lang }),
            t('tables.startTime', {}, { locale: lang }),
            t('tables.endTime', {}, { locale: lang }),
            t('tables.remark', {}, { locale: lang }),
            t('tables.serviceType', {}, { locale: lang }),
            t('tables.agent', {}, { locale: lang }),
            t('tables.status', {}, { locale: lang })
        ];

        const clientActions1 = ['client'];
        const clientActions2 = ['transfer', 'request'];
        const clientActions3 = ['message', 'request'];

        // Computed
        const clients = computed(() => {
            return store.state.business.customer;
        });

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        const selectedBranch = computed(() => {
            return store.state.branch.branch;
        });

        // Method
        const formatConversations = (conversations: any) => {
            state.formatClientsConversation = [];
            state.clientConversation = conversations;

            // Get the last conversation
            // Temporary solution for multiple conversation per client
            // Current concept have change to 1 client only have 1 conversation
            let agentName = '-';
            let agentID = null;

            const conversation = conversations[conversations.length - 1];

            if (conversation) {
                if (conversation.agent) {
                    agentName = conversation.agent.name;
                    agentID = conversation.agent.id;
                }

                // If got transfer change status to pending
                if (conversation.transfer) {
                    conversation.status = 3;
                }

                // 0-WAITING, 1-ACTIVE, 2-CLOSED, 3-PENDING (Not inside api, custom status)
                let conversationStatus = '';
                switch (conversation.status) {
                    case 3:
                        conversationStatus = 'Pending';
                        break;
                    case 0:
                        conversationStatus = 'Waiting';
                        break;
                    case 1:
                        conversationStatus = 'Active';
                        break;
                    case 2:
                        conversationStatus = 'Closed';
                        break;
                }

                state.client = { name: conversation.user.name };
                let time = date.formatDate(
                    conversation.updatedAt,
                    'YYYY-MM-DD hh:mm A'
                );

                state.formatClientsConversation.push({
                    id: conversation.id,
                    dateTime: time,
                    ticketId: conversation.referenceNo,
                    issueType: conversation.issueType.name,
                    lastAgent: { name: agentName, id: agentID },
                    user: {
                        name: conversation.user.name,
                        id: conversation.user.id
                    },
                    status: conversationStatus
                });
            }

            store.dispatch(
                'conversation/setAllClientConvoList',
                state.formatClientsConversation
            );
        };

        const formatAppointments = async (userId: any) => {
            // Testing
            // Api helpdesk appointment/list
            // branch id: cb83127c-cfb3-49f6-874f-a5a40422bd03
            // user id: 3b4b5c02-e71d-41a6-a480-27411503e13a

            const results = await store.dispatch(
                'appointment/getAppointments',
                {
                    userId: userId,
                    page: state.currentPage
                }
            );

            const formatResult = orderBy(
                results.appointments,
                ['createdAt'],
                ['desc']
            );

            if (state.appointments.length > 0) {
                state.appointments = [];
            }

            if (formatResult) {
                formatResult.forEach((result: any) => {
                    let conversationStatus = '';

                    switch (result.status) {
                        case AppointmentStatus.REJECTED:
                            conversationStatus = 'Rejected';
                            break;
                        case AppointmentStatus.ACCEPTED:
                            conversationStatus = 'Accepted';
                            break;
                        case AppointmentStatus.PENDING:
                            conversationStatus = 'Pending';
                            break;
                        case AppointmentStatus.CANCELLED:
                            conversationStatus = 'Cancelled';
                            break;
                    }

                    state.appointments.push({
                        selectedDate: result.selectedDate,
                        startTime: result.startTime,
                        endTime: result.endTime,
                        remark: result.remark == '' ? '-' : result.remark,
                        serviceTypes: result.serviceTypes,
                        agent: '-',
                        appointmentStatus: {
                            text: conversationStatus,
                            appointmentID: result.id
                        }
                    });
                });
            }
        };

        const formatData = (data: any) => {
            let resultsList: any = [];
            if (data) {
                data.forEach((element: any) => {
                    resultsList.push({
                        dateTime: element.dateTime,
                        client: {
                            id: element.user.id,
                            name: element.user.name,
                            type: 'link',
                            conversation: element
                        },
                        ticketId: element.ticketId,
                        issueType: element.issueType,
                        lastAgent: element.lastAgent,
                        status: element.status
                    });
                });
                return resultsList;
            }
        };

        const changeStatus = (status: any) => {
            store.dispatch('conversation/setAllClientConvoStatus', status);
        };

        const updateTab = (value: any) => {
            emit('update-tab', value);
        };

        const ticketIdState = (value: any) => {
            store.dispatch('conversation/setAllClientConvoPending', value);
        };

        const searchResult = async () => {
            const filterList = store.state.filter.clientFilter;
            if (selectedBusinessId.value && filterList) {
                if (state.formatClients.length > 0) {
                    state.formatClients = [];
                }
                let query = {
                    page: state.currentPage,
                    agentId: filterList.agent ? filterList.agent.id : '',
                    keyword: filterList.client ? filterList.client.name : '',
                    limit: 20
                };
                const result: any = await store.dispatch(
                    'business/getCustomer',
                    query
                );
                if (result.pagination) {
                    state.pagination = result.pagination;
                }

                clients.value.forEach(async (client: any) => {
                    let conversation = [];

                    if (client.latestConversationId) {
                        const conversationData = await store.dispatch(
                            'conversation/getOneConversation',
                            {
                                isDownward: 0,
                                conversationId: client.latestConversationId
                            }
                        );

                        conversation = conversationData.conversations[0];
                    }

                    state.formatClients.push({
                        client: {
                            id: client.id,
                            name: client.name,
                            type: 'link',
                            conversation: conversation
                        },
                        phone: client.phone,
                        lastChat:
                            date.formatDate(
                                client.latestConversationAt,
                                'YYYY-MM-DD'
                            ) ?? '-'
                    });
                });
            }
        };

        const updateConfirm = async (filterList: any) => {
            filterList.page = FilterType.CLIENT;
            await store.dispatch('filter/setFilterList', filterList);
        };

        const updateCustomer = (value: any) => {
            state.currentPage = 1;
            searchResult();
            state.displayPage = value;
        };

        const reset = () => {
            state.selectedAgent = {};
            state.selectedClient = {};
            state.selectedIssueType = {};
            state.selectedStatus = {};
            state.reset = true;
            setTimeout(() => {
                state.reset = false;
            }, 3000);
            filterStore.clear();
            store.dispatch('filter/clearFilterList');
            if (state.client.name) {
                viewClient();
            } else {
                searchResult();
            }
        };

        const viewClientButtonPressed = async (id: any) => {
            if (store.state.role.permissions.conversation?.list) {
                if (!id || id == 1) {
                    id = router.currentRoute.value.params.id;
                    state.currentPage = 1;
                }

                const issueTypeIds = state.selectedIssueType
                    ? state.selectedIssueType.id
                    : '';
                const result = await store.dispatch(
                    'conversation/getOneConversation',
                    {
                        userId: id,
                        isDownward: 0,
                        page: state.currentPage,
                        issueTypeIds: issueTypeIds,
                        statuses: state.selectedStatus.value,
                        agentId: state.selectedAgent.id
                    }
                );

                if (state.pagination) {
                    state.pagination = {} as any;
                }

                if (result.pagination) {
                    state.pagination = result.pagination;
                }
                formatConversations(result.conversations);
                formatAppointments(id);
            }
        };

        const viewClient = async () => {
            if (store.state.role.permissions.conversation?.list) {
                let id = router.currentRoute.value.params.id;
                state.currentPage = 1;
                const issueTypeIds = state.selectedIssueType
                    ? state.selectedIssueType.id
                    : '';
                const result = await store.dispatch(
                    'conversation/getOneConversation',
                    {
                        userId: id,
                        isDownward: 0,
                        page: state.currentPage,
                        issueTypeIds: issueTypeIds,
                        statuses: state.selectedStatus.value,
                        agentId: state.selectedAgent.id
                    }
                );

                if (result.pagination) {
                    state.pagination = result.pagination;
                }

                formatConversations(result.conversations);
                formatAppointments(id);
            }
        };

        const selectPagePressed = (page: number) => {
            state.currentPage = page;
            if (state.client.name) {
                viewClientButtonPressed(router.currentRoute.value.params.id);
            } else {
                searchResult();
            }
        };

        const checkRoute = () => {
            setTimeout(async () => {
                if (router.currentRoute.value.params.id) {
                    store.dispatch('menu/setSelectedShortcut', 'clients');
                    tab.value = 'clients';
                }
            }, 500);
        };

        const back = () => {
            state.pagination = {
                page: 0,
                totalPage: 0,
                limit: 0,
                total: 0
            };
            state.formatClientsConversation = [];
            state.client = [];
            state.currentPage = 1;
            searchResult();
            router.push('/helpdesk');
        };

        const requestConversationButtonPressed = (ticketId: string) => {
            props.requestConversationButton(ticketId);
        };

        const transferConversationButtonPressed = (ticketId: string) => {
            props.transferConversationButton(ticketId);
        };

        const ticketIDLinkPressed = (ticketId: string) => {
            props.ticketIDLink(ticketId);
        };

        const checkIfUrlRedirect = async () => {
            const userId = router.currentRoute.value.query.id;

            if (router.currentRoute.value.path.includes('user', 1)) {
                viewClientButtonPressed(userId);
            }
        };

        // Message Button Condition
        const messageButtonCondition = (list: any) => {
            return (
                checkIsClosed(list) ||
                (checkIsActive(list) && belongToAgent(list)) ||
                checkNoStatus(list)
            );
        };

        const checkIsClosed = (list: any) => {
            if (list.status == undefined) {
                return (
                    list.client.conversation.status == ConversationStatus.CLOSED
                );
            }
            return list.status == 'Closed';
        };

        const checkIsActive = (list: any) => {
            if (list.status == undefined) {
                return (
                    list.client.conversation.status == ConversationStatus.ACTIVE
                );
            }
            return list.status == 'Active';
        };

        const belongToAgent = (list: any) => {
            if (list.lastAgent && list.lastAgent.id) {
                return list.lastAgent.id == store.state.user.user?.id;
            } else {
                return false;
            }
        };

        const checkNoStatus = (list: any) => {
            if (list.status == undefined) {
                if (list.client.conversation.length == 0) {
                    return true;
                }
                return false;
            }
        };

        // Watch
        watch(router.currentRoute, async (to, from) => {
            if (to.params.id) {
                state.currentPage = 1;
                viewClientButtonPressed(to.params.id);
                checkRoute();
            }
        });

        watch(selectedBranch, async (currentValue) => {
            if (currentValue) {
                searchResult();
            }
        });

        // Mounted
        onMounted(searchResult);
        onMounted(checkRoute);
        onMounted(checkIfUrlRedirect);

        return {
            state,
            tab: ref('add'),
            selectPagePressed,
            searchResult,
            back,
            clientHeaders1,
            clientLeftAlign1,
            clientActions1,
            clientHeaders2,
            clientActions2,
            requestConversationButtonPressed,
            transferConversationButtonPressed,
            ticketIDLinkPressed,
            updateConfirm,
            viewClient,
            reset,
            updateCustomer,
            selectedBranch,
            updateTab,
            ticketIdState,
            allClientConvo,
            formatData,
            changeStatusConvo,
            changeStatus,
            clientHeaders3,
            clientActions3,
            messageButtonCondition
        };
    }
});
</script>
